<template>
  <div class="summary-modal">
    <div class="summary-modal-header">
      <div class="summary-modal-header__item">
        <span class="summary-modal-header__grayed">Индикатор дефицита:</span>
        {{ rowData.deficitIndicator }}
      </div>

      <div class="summary-modal-header__item">
        <span class="summary-modal-header__grayed">Вес лота:</span>
        {{ rowData.lotWeight }} %
      </div>

      <div class="summary-modal-header__item">
        <span class="summary-modal-header__grayed">Min ставка:</span>
        {{ rowData.minBid }} ₽
      </div>

      <div class="summary-modal-header__item">
        <span class="summary-modal-header__grayed">Max ставка:</span>
        {{ rowData.maxBid }} ₽
      </div>

      <div class="summary-modal-header__item">
        <span class="summary-modal-header__grayed">Выбрано пост-ков:</span>
        {{ rowData.carrierCount }}
      </div>

      <div class="summary-modal-header__item">
        <span class="summary-modal-header__grayed">Затраты:</span>
        {{ rowData.lotCost }} ₽
      </div>
    </div>

    <ObTable
      ref="carriersTable"
      class="summary-modal-table"
      :columns="columns"
      :remote-opt="{
        method: api.tendersScenarios.getTenderScenarioOffersByUuidsAndLot,
        contentKey: 'carriers',
        arguments: {
          tenderUuid,
          scenarioUuid,
          lotUuid: rowData.lotUuid
        }
      }"
      :functional-panel="true"
      data-qa="viewLotSummaryTable"
    />
  </div>
</template>

<script>
  import ObTable from 'common-components/src/obComponents/obTable'
  import api from '@/api'

  export default {
    name: 'view-lot-summary',
    components: {
      ObTable
    },
    props: {
      tenderUuid: {
        type: String,
        required: true
      },
      scenarioUuid: {
        type: String,
        required: true
      },
      rowData: {
        type: Object,
        required: true
      }
    },
    watch: {
      rowData () {
        this.$refs.carriersTable.loadData({ init: true })
      }
    },
    data () {
      return {
        api,
        columns: [
          {
            key: 'title',
            title: 'Поставщик'
          },
          {
            key: 'carriageCount',
            title: 'Гарант. объемы',
            isAlignRight: true
          },
          {
            key: 'bid',
            title: 'Ставка пост-ка, ₽',
            isAlignRight: true
          },
          {
            key: 'carriageQuote',
            title: 'Квота в лоте',
            isAlignRight: true
          },
          {
            key: 'cost',
            title: 'Сумма затрат в лоте, ₽',
            isAlignRight: true
          },
          {
            key: 'partInTotalVolume',
            title: 'Доля в объеме, %',
            isAlignRight: true,
            html: (column) => this.roundFieldValue(column.partInTotalVolume)
          },
          {
            key: 'partInTotalCosts',
            title: 'Доля в затратах, %',
            isAlignRight: true,
            html: (column) => this.roundFieldValue(column.partInTotalCosts)
          }
        ]
      }
    },
    methods: {
      roundFieldValue (value) {
        return value.toFixed(2)
      }
    }
  }
</script>

<style lang="scss" scoped>
  .summary-modal-header {
    display: grid;
    grid-column-gap: 30px;
    grid-auto-flow: column;
    grid-auto-columns: max-content;
    margin-bottom: 20px;
    color: $background-black;

    &__item {
      display: inline-flex;
    }

    &__grayed {
      color: $gray-slate;
      font-weight: normal;
      margin-right: 8px;
    }
  }

  .summary-modal-table {
    border: 1px solid $lavender;
  }

  ::v-deep {
    .summary-modal-table {
      th, td {
        &:nth-last-of-type(-n + 4) {
          background-color: rgba(214, 226, 246, 0.2); // TODO use variables
        }
      }
    }
  }
</style>
